000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. SAMPLE001.
000020 DATA DIVISION.
000030 WORKING-STORAGE SECTION.
000040 01 N5 PIC N(5) VALUE NC"日本".
000050 88 日本 VALUE N"日本".
000060 88 世界 VALUE N"世界".
000070 01 GRP-1.
000080    02 N5-2 PIC N(5) VALUE N"世界".
000090    02 X PIC X(5) VALUE "AB".
000100 01 初期値 PIC N(5) VALUE "ABCDE".
000110 01 日本語編集 PIC NNBNN VALUE NC"本日晴天".
000120 01 日本語編集２ PIC NBN VALUE NC"日本".
000130 01 CMP-2 COMP-2 VALUE 12345.
000140 01 数字編集 PIC Z,ZZ9 VALUE 1234.
000150 01 GRP-2.
000160    02 ELEM-1 PIC N(5) VALUE NC"ＡＢＣ".
000170    02 ELEM-2 REDEFINES ELEM-1 PIC X(5).
000180 PROCEDURE DIVISION.
000190 MAIN00.
000200* =========================================
000210* 日本語初期値
000220     IF N5 = NC"日本" DISPLAY "001 OK" ELSE DISPLAY "001 NG".
000230     IF N5-2 = NC"世界" DISPLAY "002 OK" ELSE DISPLAY "002 NG".
000240     IF 日本語編集 = NC"本日　晴天"
000250        DISPLAY "003 OK" ELSE DISPLAY "003 NG".
000260     IF 初期値 = NC"ＡＢＣＤＥ"
000270        DISPLAY "003-2 OK" ELSE DISPLAY "003-2 NG: ".
000280* =========================================
000290* 日本語項目への転記 
000300* MOVE 日本語定数 TO 日本語項目
000310     MOVE N"１２３" TO N5.
000320     IF N5 = N"１２３"
000330        DISPLAY "004 OK" ELSE DISPLAY "004 NG".
000340     IF N"１２３" = N5
000350        DISPLAY "005 OK" ELSE DISPLaY "005 NG".
000360* MOVE 日本語項目 TO 日本語項目
000370     MOVE N5-2 TO N5.
000380     IF N5 = N5-2
000390        DISPLAY "006 OK" ELSE DISPLAY "006 NG".
000400     IF NC"日本" = NC"日本　　"
000410        DISPLAY "007 OK" ELSE DISPLAY "007 NG".
000420* MOVE 日本語編集 TO 日本語項目
000430     MOVE 日本語編集 TO N5.
000440     IF N5 = NC"本日　晴天"
000450        DISPLAY "008 OK" ELSE DISPLAY "008 NG".
000460* MOVE 数字 TO 日本語項目
000470     MOVE 123 TO N5.
000480     IF N5 = NC"００１２３"
000490        DISPLAY "009 OK" ELSE DISPLAY "009 NG".
000500* 文字定数 TO 日本語項目
000510     MOVE "ｱｲﾊﾞB" TO N5.
000520     IF N5 = NC"アイハ゛Ｂ"
000530        DISPLAY "010 OK" ELSE DISPLAY "010 NG".
000540* MOVE 英数字項目 TO 日本語項目
000550     MOVE X TO N5.
000560     IF N5 = NC"ＡＢ"
000570        DISPLAY "011 OK" ELSE DISPLAY "011 NG".
000580* MOVE 数字項目 TO 日本語
000590     MOVE CMP-2 TO N5.
000600     IF N5 = NC"１２３４５"
000610        DISPLAY "012 OK" ELSE DISPLAY "012 NG".
000620* MOVE SPACE TO 日本語項目
000630     MOVE SPACE TO N5.
000640     IF N5 = SPACE
000650        DISPLAY "013 OK" ELSE DISPLAY "013 NG".
000660* MOVE ZERO TO 日本語項目
000670     MOVE ZERO TO N5.
000680     IF N5 = ALL NC"０"
000690        DISPLAY "014 OK" ELSE DISPLAY "014 NG".
000700* MOVE HIGH-VALUE TO N5.
000710     MOVE HIGH-VALUE TO N5.
000720     DISPLAY "015 '日本語項目には表意定数HIGH-VALUEを転記する"
000730     "ことはできない'と出力されればOK".
000740* MOVE LOW-VALUE TO N5.
000750     MOVE LOW-VALUE TO N5.
000760     DISPLAY "016 '日本語項目には表意定数LOW-VALUEを転記する"
000770     "ことはできない'と出力されればOK".
000780* MOVE QUOTE TO N5.
000790     MOVE LOW-VALUE TO N5.
000800     DISPLAY "017 '日本語項目には表意定数QUOTEを転記することは"
000810     "できない'と出力されればOK".
000820* =========================================
000830* 日本語編集項目への転記 
000840* MOVE 文字定数 TO 日本語編集項目
000850     MOVE "ABCDE" TO 日本語編集.
000860     IF 日本語編集 = NC"ＡＢ　ＣＤ"
000870        DISPLAY "018 OK" ELSE DISPLAY "018 NG".
000880* MOVE 英数字項目 TO 日本語編集.
000890     MOVE "VWXYZ" TO X.
000900     MOVE X TO 日本語編集.
000910     IF 日本語編集 = NC"ＶＷ　ＸＹ"
000920        DISPLAY "019 OK" ELSE DISPLAY "019 NG: " 日本語編集.
000930* MOVE 数字定数 TO 日本語編集項目
000940     MOVE 12345 TO 日本語編集.
000950     IF 日本語編集 = NC"２３　４５"
000960        DISPLAY "020 OK" ELSE DISPLAY "020 NG".
000970* MOVE 数字項目 TO 日本語編集項目
000980     MOVE CMP-2 TO 日本語編集.
000990     IF 日本語編集 = NC"２３　４５"
001000        DISPLAY "021 OK" ELSE DISPLAY "021 NG".
001010* MOVE 数字編集項目 TO 日本語編集項目
001020     MOVE 数字編集 TO 日本語編集
001030     IF 日本語編集 = NC"１，　２３"
001040        DISPLAY "022 OK" ELSE DISPLAY "022 NG: " 日本語編集.
001050* MOVE 日本語 TO 日本語編集
001060     MOVE NC"本日晴天" TO N5.
001070     MOVE N5 TO 日本語編集.
001080     IF 日本語編集 = NC"本日　晴天"
001090        DISPLAY "023 OK" ELSE DISPLAY "023 NG".
001100* MOVE 日本語編集 TO 日本語編集
001110     MOVE 日本語編集２ TO 日本語編集.
001120     IF 日本語編集 = NC"日　　本　"
001130        DISPLAY "024 OK" ELSE DISPLAY "024 NG".
001140* MOVE 日本語定数 TO 日本語編集
001150     MOVE NC"アジア" TO 日本語編集.
001160     IF 日本語編集 = NC"アジ　ア"
001170        DISPLAY "025 OK" ELSE DISPLAY "025 NG".
001180* MOVE 表意定数 TO 日本語編集項目
001190     MOVE ZERO TO 日本語編集.
001200     IF 日本語編集 = NC"００　００"
001210        DISPLAY "026 OK" ELSE DISPLAY "026 NG: " 日本語編集.
001220     MOVE SPACE TO 日本語編集.
001230     IF 日本語編集 = ALL NC"　"
001240        DISPLAY "027 OK" ELSE DISPLAY "027 NG".
001250     MOVE HIGH-VALUE TO 日本語編集.
001260     DISPLAY "028 '日本語項目には表意定数HIGH-VALUEを転記する"
001270     "ことはできない'と出力されればOK".
001280     MOVE LOW-VALUE TO 日本語編集.
001290     DISPLAY "029 '日本語項目には表意定数HIGH-VALUEを転記する"
001300     "ことはできない'と出力されればOK".
001310     MOVE QUOTE TO 日本語編集.
001320     DISPLAY "030 '日本語項目には表意定数QUOTEを転記する"
001330     "ことはできない'と出力されればOK".
001340        
001350* 条件名条件
001360     SET 日本 TO TRUE.
001370     IF N5 = N"日本"
001380        DISPLAY "031 OK" ELSE DISPLAY "031 NG: ".
001390     IF 日本
001400        DISPLAY "032 OK" ELSE DISPLAY "032 NG: ".
001410* 部分参照
001420     MOVE N"世界遺産" TO N5-2.
001430     IF N5-2(3:) = N"遺産"
001440        DISPLAY "033 OK" ELSE DISPLAY "033 NG: ".
001450* INITIALIZE    
001460     INITIALIZE GRP-1.
001470     IF GRP-1 = "　　　　　     "
001480        DISPLAY "034 OK" ELSE DISPLAY "034 NG: ".
001490* 初期値
001500     IF 初期値 = NC"ＡＢＣＤＥ"
001510        DISPLAY "035 OK" ELSE DISPLAY "035 NG: ".
001520* ====================================================
001530* 比較
001540* 集団項目 VS 日本語項目
001550     IF GRP-2 = NC"ＡＢＣ"
001560        DISPLAY "036 OK" ELSE DISPLAY "036 NG: ".
001570* 英数字項目 VS 日本語項目
001580     IF ELEM-2 = NC"ＡＢＣ"
001590        CONTINUE.
001600     DISPLAY "037 '日本語項目は英数字と比較することができない'"
001610     "というエラーであればOK".
001620     STOP RUN.