000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. 倉庫マスタ作成.
000020 ENVIRONMENT DIVISION.
000030 INPUT-OUTPUT SECTION.
000040 FILE-CONTROL.
000050     SELECT 倉庫マスタ ASSIGN TO "倉庫マスタ.sqlite3"
000060         ORGANIZATION IS INDEXED
000070         ACCESS MODE IS DYNAMIC
000080         RECORD KEY IS Ｍ倉庫コード
000090         FILE STATUS IS ファイルステータス.
000100*
000110     SELECT 倉庫マスタＣＳＶ ASSIGN TO "倉庫マスタ初期データ.CSV"
000120         ORGANIZATION IS LINE SEQUENTIAL.
000130 DATA DIVISION.
000140 FILE SECTION.
000150 FD 倉庫マスタ.
000160 01 倉庫マスタレコード.
000170    COPY 倉庫レコード.
000180 FD 倉庫マスタＣＳＶ.
000190 01 ＣＳＶレコード          PIC X(100).
000200 WORKING-STORAGE SECTION.
000210 01 ファイルステータス      PIC X(2).
000220 01 ＣＳＶデータ.
000230    COPY 倉庫レコード REPLACING //Ｍ// BY //ＷＳー//.  *> 部分置換指定。先頭の'Ｍ'を'ＷＳ－'に変える
000240 PROCEDURE DIVISION.
000250 開始処理.
000260     OPEN INPUT 倉庫マスタＣＳＶ.
000270     OPEN OUTPUT 倉庫マスタ.
000280*
000290     PERFORM FOREVER
000300*       CSVファイルを読み込む。AT ENDなら終了
000310        READ 倉庫マスタＣＳＶ
000320           AT END
000330              EXIT PERFORM
000340        END-READ
000350*       CSVレコードの最後にカンマ(',')を付与する。
000360        STRING FUNCTION TRIM(ＣＳＶレコード) "," 
000370           DELIMITED BY SIZE INTO ＣＳＶレコード
000380*       CSVレコードを項目単位に分解(","で区切る)
000390        UNSTRING ＣＳＶレコード
000400           DELIMITED BY ","
000410           INTO ＷＳー倉庫コード,  ＷＳー倉庫名, 
000420                ＷＳー所在地,      ＷＳー電話番号 
000000        DISPLAY "'" ＣＳＶデータ "'"
000430*       倉庫マスタへの書き込み
000440        WRITE 倉庫マスタレコード FROM ＣＳＶデータ
000450        IF ファイルステータス NOT = "00"
000460           DISPLAY "マスタファイル書き込みエラー "
000470           "ファイルステータス=" ファイルステータス
000480        END-IF
000490     END-PERFORM.
000500*
000510     CLOSE 倉庫マスタＣＳＶ.
000520     CLOSE 倉庫マスタ.
000530     STOP RUN.