000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. 顧客マスタ作成.
000020 ENVIRONMENT DIVISION.
000030 INPUT-OUTPUT SECTION.
000040 FILE-CONTROL.
000050     SELECT 顧客マスタ ASSIGN TO "顧客マスタ.sqlite3"
000060         ORGANIZATION IS INDEXED
000070         ACCESS MODE IS DYNAMIC
000080         RECORD KEY IS Ｍ顧客コード
000090         FILE STATUS IS ファイルステータス.
000100*
000110     SELECT 顧客マスタＣＳＶ ASSIGN TO "顧客マスタ初期データ.CSV"
000120         ORGANIZATION IS LINE SEQUENTIAL.
000130 DATA DIVISION.
000140 FILE SECTION.
000150 FD 顧客マスタ.
000160 01 顧客マスタレコード.
000170    COPY 顧客レコード.
000180 FD 顧客マスタＣＳＶ.
000190 01 ＣＳＶレコード          PIC X(100).
000200 WORKING-STORAGE SECTION.
000210 01 ファイルステータス      PIC X(2).
000220 01 ＣＳＶデータ.
000230    COPY 顧客レコード REPLACING //Ｍ// BY //ＷＳー//.  *> 部分置換指定。先頭の'Ｍ'を'ＷＳ－'に変える
000240 PROCEDURE DIVISION.
000250 開始処理.
000260     OPEN INPUT 顧客マスタＣＳＶ.
000270     OPEN OUTPUT 顧客マスタ.
000280*
000290     PERFORM FOREVER
000300*       CSVファイルを読み込む。AT ENDなら終了
000310        READ 顧客マスタＣＳＶ
000320           AT END
000330              EXIT PERFORM
000340        END-READ
000350*       CSVレコードの最後にカンマ(',')を付与する。
000360        STRING FUNCTION TRIM(ＣＳＶレコード) "," 
000370           DELIMITED BY SIZE INTO ＣＳＶレコード
000350*       CSVレコードを項目単位に分解(","で区切る)
000360        UNSTRING ＣＳＶレコード
000370           DELIMITED BY ","
000380           INTO ＷＳー顧客コード,  ＷＳー顧客名, 
000390                ＷＳー住所,        ＷＳー電話番号, 
000400                ＷＳーメールアドレス
000000        DISPLAY "'" ＣＳＶデータ "'"
000410*       顧客マスタへの書き込み
000420        WRITE 顧客マスタレコード FROM ＣＳＶデータ
000430        IF ファイルステータス NOT = "00"
000440           DISPLAY "マスタファイル書き込みエラー "
000450           "ファイルステータス=" ファイルステータス
000460        END-IF
000470     END-PERFORM.
000480*
000490     CLOSE 顧客マスタＣＳＶ.
000500     CLOSE 顧客マスタ.
000510     STOP RUN.