000000 identification division.
000010 program-id. sample001.
000020 data division.
000030 working-storage section.
000040 01 init-value.
000050    02  pic x(30) value "NAKANO/HACHIOJI//TAKAO********".
000060    02  pic x(10) value space.
000070    02  pic x(10) value space.
000080    02  pic x(10) value space.
000090    02  pic xx    value space.
000100    02  pic xx    value space.
000110    02  pic xx    value space.
000120    02  pic 99    value zero.
000130    02  pic 99    value zero.
000140    02  pic 99    value zero.
000150    02  pic 99    value 1.
000160    02  pic 99    value 0.
000170 01 work.
000180    02 send-a pic x(30).
000190    02 rcv-1  pic x(10).
000200    02 rcv-2  pic x(10).
000210    02 rcv-3  pic x(10).
000220    02 del-1  pic xx.
000230    02 del-2  pic xx.
000240    02 del-3  pic xx.
000250    02 ctr-1  pic 99.
000260    02 ctr-2  pic 99.
000270    02 ctr-3  pic 99.
000280    02 ptr-a  pic 99.
000290    02 tall-a pic 99.
000300 procedure division.
000310 main00.
000320     move init-value to work.
000330*    send-aの内容をrcv-1, rcv-2, rcv-3に転記
000340     unstring send-a
000350         into rcv-1 rcv-2 rcv-3
000360         with pointer ptr-a.
000370     if rcv-1 = "NAKANO/HAC" and
000380        rcv-2 = "HIOJI//TAK" and
000390        rcv-3 = "AO********"
000400         display "001 OK"
000410     else
000420         display "001 NG"
000430         display "   rcv-1:[" rcv-1 "]"
000440         display "   rcv-2:[" rcv-2 "]"
000450         display "   rcv-3:[" rcv-3 "]"
000460     end-if
000470*
000480     move init-value to work.
000490*    区切り文字に"/"を指定してsend-aの値をrcv-1, rcv-2, rcv-3に転記
000500     UNSTRING SEND-A
000510       DELIMITED BY "/"
000520       INTO RCV-1 COUNT IN CTR-1
000530            RCV-2 COUNT IN CTR-2
000540            RCV-3 COUNT IN CTR-3
000550       WITH POINTER PTR-A TALLYING IN TALL-A. 
000560     if rcv-1 = "NAKANO    " and
000570        rcv-2 = "HACHIOJI  " and
000580        rcv-3 = "          " and 
000590        ctr-1 = 6    and
000600        ctr-2 = 8    and
000610        ctr-3 = 0    and
000620        ptr-a = 18 and tall-a = 3
000630         display "002 OK"
000640     else
000650         display "002 NG"
000660         display "  rcv-1:[" rcv-1 "]"
000670         display "  rcv-2:[" rcv-2 "]"
000680         display "  rcv-3:[" rcv-3 "]"
000690         display "  ptr-a:" ptr-a
000700         display "  tall-a:" tall-a
000710     end-if.
000720*
000730     move init-value to work.
000740     move 5 to tall-a.
000750*    区切り文字にALL指定の"/"と"*"を指定して、send-aの値を
000760*    rcv-1, rcv-2, rcv-3に転記する。
000770     UNSTRING SEND-A
000780       DELIMITED BY ALL "/" OR ALL "*"
000790       INTO RCV-1 DELIMITER IN DEL-1
000800                  COUNT IN CTR-1
000810            RCV-2 DELIMITER IN DEL-2
000820                  COUNT IN CTR-2
000830            RCV-3 DELIMITER IN DEL-3
000840                  COUNT IN CTR-3
000850       WITH POINTER PTR-A TALLYING IN TALL-A. 
000860     if rcv-1 = "NAKANO    " and
000870        rcv-2 = "HACHIOJI  " and
000880        rcv-3 = "TAKAO     " and 
000890        del-1 = "/ " and
000900        del-2 = "/ " and
000910        del-3 = "* " and
000920        ctr-1 = 6    and
000930        ctr-2 = 8    and
000940        ctr-3 = 5    and
000950        ptr-a = 31 and tall-a = 8
000960         display "003 OK"
000970     else
000980         display "003 NG"
000990         display "  rcv-1:[" rcv-1 "]"
001000         display "  rcv-2:[" rcv-2 "]"
001010         display "  rcv-3:[" rcv-3 "]"
001020         display "  del-1:[" del-1 "]"
001030         display "  del-2:[" del-2 "]"
001040         display "  del-3:[" del-3 "]"
001050         display "  ctr-1: " ctr-1
001060         display "  ctr-2: " ctr-2
001070         display "  ctr-3: " ctr-3
001080         display "  ptr-a:" ptr-a
001090         display "  tall-a:" tall-a
001100     end-if.
001110* Overflow Test
001120     move init-value to work.
001130     unstring send-a
001140         into rcv-1 rcv-2 rcv-3
001150         with pointer ptr-a
001160     on overflow
001170         display "004 NG"
001180     not overflow
001190         display "004 OK"
001200     end-unstring.
001210*
001220     move init-value to work.
001230     UNSTRING SEND-A
001240       DELIMITED BY "/"
001250       INTO RCV-1 COUNT IN CTR-1
001260            RCV-2 COUNT IN CTR-2
001270            RCV-3 COUNT IN CTR-3
001280       WITH POINTER PTR-A TALLYING IN TALL-A
001290     on overflow
001300         display "005 OK"
001310     not overflow
001320         display "005 NG"
001330     end-unstring.
001340*
001350     move init-value to work.
001360     UNSTRING SEND-A
001370       DELIMITED BY ALL "/" OR ALL "*"
001380       INTO RCV-1 DELIMITER IN DEL-1
001390                  COUNT IN CTR-1
001400            RCV-2 DELIMITER IN DEL-2
001410                  COUNT IN CTR-2
001420            RCV-3 DELIMITER IN DEL-3
001430                  COUNT IN CTR-3
001440       WITH POINTER PTR-A TALLYING IN TALL-A
001450     on overflow
001460         display "006 NG"
001470     not overflow
001480         display "006 OK"
001490     end-unstring.
001500*
001510     move 1000 to ptr-a.
001520     UNSTRING SEND-A
001530       DELIMITED BY ALL "/" OR ALL "*"
001540       INTO RCV-1 DELIMITER IN DEL-1
001550                  COUNT IN CTR-1
001560       WITH POINTER PTR-A TALLYING IN TALL-A
001570     on overflow
001580         display "007 OK"
001590     not overflow
001600         display "007 NG"
001610     end-unstring.
001620*    関数が利用できることの確認
001630     unstring 
001640         FUNCTION UPPER-CASE("nakano/hachioji//takao********")
001650         delimited by all function max("+", "/") or
001660                          function min("*", "+")
001670         into rcv-1 rcv-2 rcv-3.
001680     if rcv-1 = "NAKANO" and
001690        rcv-2 = "HACHIOJI" and
001700        rcv-3 = "TAKAO"
001710         display "008 OK"
001720     else
001730         display "008 NG"
001740         display "   rcv-1:[" rcv-1 "]"
001750         display "   rcv-2:[" rcv-2 "]"
001760         display "   rcv-3:[" rcv-3 "]"
001770     end-if
001780