000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. INDFILE003.
000020 ENVIRONMENT DIVISION.
000030 INPUT-OUTPUT SECTION.
000040 FILE-CONTROL.
000050     SELECT 果物ファイル ASSIGN TO "./果物ファイル.sqlite3"
000060            ORGANIZATION IS INDEXED
000070            RECORD KEY IS 商品番号 OF 果物レコード
000080            ACCESS MODE IS DYNAMIC.
000090 DATA DIVISION.
000100 FILE SECTION.
000110 FD 果物ファイル.
000120 01 果物レコード.
000130    02 商品番号 PIC X(3).
000140    02 名前     PIC N(10).
000150    02 数量     PIC 9(5).
000160 PROCEDURE DIVISION.
000170 MAIN00.
000180*    ファイルのオープン
000190     OPEN I-O 果物ファイル.
000200*    主キー(商品番号)に103を指定してSTART文を実行する
000210     MOVE 103 TO 商品番号 OF 果物ファイル.
000220     START 果物ファイル
000230     INVALID
000240        DISPLAY "START: レコードが見つからない"
000250        STOP RUN
000260     END-START.
000270     PERFORM FOREVER
000280        READ 果物ファイル NEXT
000290        AT END
000300           EXIT PERFORM
000310        END-READ
000320        DISPLAY 果物レコード
000330     END-PERFORM.
000340*    ファイルのクローズ
000350     CLOSE 果物ファイル.
000360     STOP RUN.