@echo off

rem コマンドプロンプトのコード系をutf-8に設定
chcp 65001

rem 環境変数の設定
set sitcobol=d:\sitcobol\sitcobol_bat.exe
set prg_path=d:\batch_sample

rem PID取得

%sitcobol% %prg_path%\PPID取得.cob
set pid=%errorlevel%

rem トランザクションCSVの用意:本体は前段のジョブから取得すべきデータであるが
rem ここでは元ファイルをコピーするのみとする

copy %prg_path%\トランザクションデータ.csv  %prg_path%\%pid%_トランザクションデータ.csv

rem 環境変数の設定(COBOL側で参照)

set tran_file=%prg_path%\%pid%_トランザクションデータ.csv
set order_file=%prg_path%\%pid%_発注.dat
set order_text=%prg_path%\%pid%_発注帳票.txt
set out_of_stock_file=%prg_path%\%pid%_欠品.dat
set out_of_stock_text=%prg_path%\%pid%_欠品帳票.txt

rem 在庫マスタ更新
%sitcobol% %prg_path%\在庫マスタ更新2.cob
if errorlevel 1 goto ERROR

rem 発注帳票作成
%sitcobol% %prg_path%\発注帳票作成2.cob
if errorlevel 1 goto ERROR

rem 欠品帳票作成
%sitcobol% %prg_path%\欠品帳票作成2.cob
if errorlevel 1 goto ERROR

rem 不必要となったファイルの削除
del %prg_path%\%pid%_トランザクションデータ.csv
del %prg_path%\%pid%_発注.dat
del %prg_path%\%pid%_欠品.dat

goto END

:ERROR
echo エラーが発生しました。
exit /b 1

:END
echo 正常に終了しました。