000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. INSERT001.
000020 DATA DIVISION.
000030 WORKING-STORAGE SECTION.
000040 01 DATA01.
000050    02  PIC X(20)  VALUE "青山 睦子".
000060    02  PIC X(100) VALUE "大阪府 牧方市".
000070    02  PIC X(20)  VALUE "岩間 年男".
000080    02  PIC X(100) VALUE "東京都 港区".
000090    02  PIC X(20)  VALUE "西山 峰雄".
000100    02  PIC X(100) VALUE "千葉県 長生村".
000110    02  PIC X(20)  VALUE "飯島 裕一".
000120    02  PIC X(100) VALUE "東京都 国分寺市".
000130 01 DATA02 REDEFINES DATA01.
000140    02  OCCURS 4.
000150        03 D-NAME PIC X(20).
000160        03 D-ADDR PIC X(100).
000170 01 I COMP-1.
000180 EXEC SQL BEGIN DECLARE SECTION END-EXEC.
000190 01 NAME PIC X(20).
000200 01 ADDR PIC X(100).
000210 EXEC SQL END DECLARE SECTION END-EXEC.
000220 PROCEDURE DIVISION.
000230 MAIN00.
000240* 'TESTDB.sqlite3'への接続
000250     EXEC SQL 
000260        CONNECT TO 'TESTDB.sqlite3'
000270     END-EXEC.
000280* SQLCODEチェック
000290     IF SQLCODE NOT = 0
000300        DISPLAY "CONNECT:    NG SQLCODE=" SQLCODE
000310        DISPLAY "               SQLMSG=" SQLMSG
000320        STOP RUN
000330     END-IF.
000340* 4件のデータを格納
000350     PERFORM VARYING I FROM 1 BY 1 UNTIL I > 4
000360        MOVE D-NAME(I) TO NAME
000370        MOVE D-ADDR(I) TO ADDR   
000380        EXEC SQL
000390          INSERT INTO address_book(name, address)
000400            VALUES (:NAME, :ADDR)
000410        END-EXEC
000420* SQLCODEチェック
000430        IF SQLCODE NOT = 0
000440           DISPLAY "INSERT:     NG SQLCODE=" SQLCODE
000450           DISPLAY "               SQLMSG= " SQLMSG
000460           DISPLAY "               SQLIMAGE=" SQLIMAGE
000470           STOP RUN
000480        END-IF
000490     END-PERFORM.
000500* COMMIT処理
000510     EXEC SQL
000520        COMMIT
000530     END-EXEC.
000540* SQLCODEチェック
000550     IF SQLCODE NOT = 0
000560        DISPLAY "COMMIT:     NG SQLCODE=" SQLCODE
000570        DISPLAY "               SQLMSG= " SQLMSG
000580        STOP RUN
000590     END-IF.
000600* データベース接続解除
000610     EXEC SQL
000620        DISCONNECT
000630     END-EXEC.
000640* SQLCODEチェック
000650     IF SQLCODE NOT = 0
000660        DISPLAY "DISCONNECT: NG SQLCODE=" SQLCODE
000670        DISPLAY "               SQLMSG= " SQLMSG
000680        STOP RUN
000690     END-IF.
000700     STOP RUN.