000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. INSERT001.
000020 DATA DIVISION.
000030 WORKING-STORAGE SECTION.
000040 01 DATA01.
000050    02  PIC X(20)  VALUE "青山 睦子".
000060    02  PIC X(100) VALUE "大阪府 牧方市".
000070    02  PIC X(20)  VALUE "岩間 年男".
000080    02  PIC X(100) VALUE "東京都 港区".
000090    02  PIC X(20)  VALUE "西山 峰雄".
000100    02  PIC X(100) VALUE "千葉県 長生村".
000110    02  PIC X(20)  VALUE "飯島 裕一".
000120    02  PIC X(100) VALUE "東京都 国分寺市".
000130 01 DATA02 REDEFINES DATA01.
000140    02  OCCURS 4.
000150        03 D-NAME PIC X(20).
000160        03 D-ADDR PIC X(100).
000170 01 I COMP-1.
000180 EXEC SQL BEGIN DECLARE SECTION END-EXEC.
000190 01 NAME PIC X(20).
000200 01 ADDR PIC X(100).
000210 EXEC SQL END DECLARE SECTION END-EXEC.
000220 PROCEDURE DIVISION.
000230 MAIN00.
000240     EXEC SQL
000250        WHENEVER SQLERROR GOTO :SQL-ERROR
000260     END-EXEC.
000270* 'TESTDB.sqlite3'への接続
000280     EXEC SQL 
000290        CONNECT TO 'TESTDB.sqlite3'
000300     END-EXEC.
000310* 4件のデータを格納
000320     PERFORM VARYING I FROM 1 BY 1 UNTIL I > 4
000330        MOVE D-NAME(I) TO NAME
000340        MOVE D-ADDR(I) TO ADDR   
000350        EXEC SQL
000360          INSERT INTO address_book(name, address)
000370            VALUES (:NAME, :ADDR)
000380        END-EXEC
000390     END-PERFORM.
000400* COMMIT処理
000410     EXEC SQL
000420        COMMIT
000430     END-EXEC.
000440* データベース接続解除
000450     EXEC SQL
000460        DISCONNECT
000470     END-EXEC.
000480     STOP RUN.
000490 SQL-ERROR.
000500     DISPLAY "SQLCODE = " SQLCODE.
000510     DISPLAY "SQLMSG=   " SQLMSG.
000520     DISPLAY "SQLIMAGE= " SQLIMAGE.
000530     STOP RUN.