000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. CREATE001.
000020 DATA DIVISION.
000030 WORKING-STORAGE SECTION.
000040 PROCEDURE DIVISION.
000050 MAIN00.
000060* データベース'TESTDB.sqlite'への接続。もし './TESTDB.sqlite3'が
000070* 存在しない場合は、作成される。
000080     EXEC SQL 
000090        CONNECT TO './TESTDB.sqlite3'
000100     END-EXEC.
000110* CONNECTの結果を確認。
000120     IF SQLCODE NOT = 0
000130        DISPLAY "CONNECT:    NG SQLCODE=" SQLCODE
000140        DISPLAY "               SQLMSG= " SQLMSG
000150        STOP RUN
000160     END-IF.
000170* テーブル(表)の作成 
000180     EXEC SQL
000190        CREATE TABLE address_book(
000200            name       char(20),
000210            address    varchar(255))
000220     END-EXEC.
000230* CREATEの結果を確認。
000240     IF SQLCODE NOT = 0
000250        DISPLAY "CREATE:     NG SQLCODE=" SQLCODE
000260        DISPLAY "               SQLMSG= " SQLMSG
000270        STOP RUN
000280     END-IF.
000290* データベースへの接続解除
000300     EXEC SQL
000310        DISCONNECT
000320     END-EXEC.
000330* DISCONNECTの結果を確認
000340     IF SQLCODE NOT = 0
000350        DISPLAY "DISCONNECT: NG SQLCODE=" SQLCODE
000360        DISPLAY "               SQLMSG= " SQLMSG
000370        STOP RUN
000380     END-IF.
000390     STOP RUN.